VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "TextBox Formatting options"
   ClientHeight    =   6285
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6015
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6285
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCreditCard 
      Height          =   450
      Left            =   240
      TabIndex        =   8
      Top             =   5160
      Width           =   3615
   End
   Begin VB.TextBox txtPhone 
      Height          =   450
      Left            =   240
      TabIndex        =   6
      Top             =   4080
      Width           =   3615
   End
   Begin VB.TextBox txtDate 
      Height          =   450
      Left            =   240
      TabIndex        =   5
      Top             =   3000
      Width           =   3615
   End
   Begin VB.TextBox txtCurrency 
      Alignment       =   1  'Right Justify
      Height          =   450
      Left            =   240
      TabIndex        =   3
      Top             =   1920
      Width           =   3615
   End
   Begin VB.TextBox txtNumber 
      Alignment       =   1  'Right Justify
      Height          =   450
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   3615
   End
   Begin VB.Label Label5 
      Caption         =   "C&redit Card Number"
      Height          =   375
      Left            =   240
      TabIndex        =   9
      Top             =   4800
      Width           =   3615
   End
   Begin VB.Label Label2 
      Caption         =   "&Phone Number"
      Height          =   375
      Left            =   240
      TabIndex        =   7
      Top             =   3720
      Width           =   3615
   End
   Begin VB.Label Label4 
      Caption         =   "D&ate"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2640
      Width           =   3615
   End
   Begin VB.Label Label3 
      Caption         =   "&Currency"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1560
      Width           =   3615
   End
   Begin VB.Label Label1 
      Caption         =   "&Number (general format)"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   480
      Width           =   3615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub txtNumber_GotFocus()
    ' filter out non-digit chars and unsignificant traling zeroes
    On Error Resume Next
    txtNumber.Text = FilterNumber(txtNumber.Text, True)
End Sub

Private Sub txtNumber_LostFocus()
    ' format as a number , grouping thousand digits
    On Error Resume Next
    If Int(CDbl(txtNumber.Text)) = CDbl(txtNumber.Text) Then
        txtNumber.Text = Format(CDbl(txtNumber.Text), "#,###,###,##0")
    Else
        txtNumber.Text = Format(CDbl(txtNumber.Text), "#,###,###,##0.###")
    End If
End Sub

Private Sub txtCurrency_GotFocus()
    ' filter out non-digit chars and unsignificant traling zeroes
    ' restore standard text color
    On Error Resume Next
    txtCurrency.Text = FilterNumber(txtCurrency.Text, True)
    txtCurrency.ForeColor = vbWindowText
End Sub

Private Sub txtCurrency_LostFocus()
    On Error Resume Next
    ' show negative values as red text
    If CDbl(txtCurrency.Text) < 0 Then
        txtCurrency.ForeColor = vbRed
    End If
    ' format currency, but don't use parentesis for negative number
    ' (FormatCurrency is a new VB6 string function)
    txtCurrency.Text = FormatCurrency(txtCurrency.Text, , , vbFalse)
End Sub

Private Sub txtDate_GotFocus()
    ' prepare to edit in short-date format
    On Error Resume Next
    txtDate.Text = Format$(CDate(txtDate.Text), "short date")
End Sub

Private Sub txtDate_LostFocus()
    ' convert to long-date format on exit
    On Error Resume Next
    txtDate.Text = Format$(CDate(txtDate.Text), "d MMMM yyyy")
End Sub

Private Sub txtPhone_GotFocus()
    ' trim embedded dashes
    txtPhone.Text = FilterString(txtPhone.Text, "0123456789")
End Sub

Private Sub txtPhone_LostFocus()
    ' add dashes if necessary
    txtPhone.Text = FormatPhoneNumber(txtPhone.Text)
End Sub

Private Sub txtCreditCard_GotFocus()
    ' trim embedded spaces
    txtCreditCard.Text = FilterNumber(txtCreditCard.Text, True)
End Sub

Private Sub txtCreditCard_LostFocus()
    ' add spaces if necessary
    txtCreditCard.Text = FormatCreditCard(txtCreditCard.Text)
End Sub


' filter out invalid characters
' (this function is used by all subsequent ones)

Function FilterString(Text As String, validChars As String) As String
    Dim i As Long, result As String
    For i = 1 To Len(Text)
        If InStr(validChars, Mid$(Text, i, 1)) Then
            result = result & Mid$(Text, i, 1)
        End If
    Next
    FilterString = result
End Function

' filter out all non-numeric digits
' optionally trims non-significant trailing zeroes

Function FilterNumber(Text As String, TrimDecimal As Boolean) As String
    Dim decSep As String, i As Long
    Dim result As String
    
    ' retrieve the decimal separator symbol
    decSep = Format$(0.1, ".")
    ' use FilterString for most of the work
    result = FilterString(Text, decSep & "-0123456789")
    
    ' only if there is a decimal part and the
    ' user requested to trim non-significant digits
    If TrimDecimal And InStr(Text, decSep) > 0 Then
        For i = Len(result) To 1 Step -1
            Select Case Mid$(result, i, 1)
                Case decSep
                    result = Left$(result, i - 1)
                    Exit For
                Case "0"
                    result = Left$(result, i - 1)
                Case Else
                    Exit For
            End Select
        Next
    End If
    
    FilterNumber = result

End Function

' format a phone number
' NOTE: this routine is US-specific

Function FormatPhoneNumber(Text As String) As String
    Dim tmp As String
    If Text <> "" Then
        ' first, get rid of all embedded dashes,if any
        tmp = FilterString(Text, "0123456789")
        ' then, re-insert them in the correct position
        If Len(tmp) <= 7 Then
            FormatPhoneNumber = Left$(tmp, 3) & "-" & Mid$(tmp, 4)
        Else
            FormatPhoneNumber = Left$(tmp, 3) & "-" & Mid$(tmp, 4, 3) & "-" & Mid$(tmp, 7)
        End If
    End If
End Function

' format a credit card number

Function FormatCreditCard(Text As String) As String
    Dim tmp As String
    If Text <> "" Then
        ' first, get rid of all embedded spaces,if any
        tmp = FilterNumber(Text, False)
        ' then, re-insert them in the correct position
        FormatCreditCard = Left$(tmp, 4) & " " & Mid$(tmp, 5, 4) & " " & Mid$(tmp, 9, 4) & " " & Mid$(tmp, 13, 4)
    End If
End Function
