VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CEllipse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------------
' The CEllipse Class
'----------------------------------------------

Option Explicit

Public Left As Single
Public Top As Single
Public Width As Single
Public Height As Single
Public Color As Long
Public FillColor As Long

Private Sub Class_Initialize()
    Color = vbBlack
    FillColor = -1            ' any negative value means "unfilled"
End Sub

' simple constructor for ease of use

Friend Sub Init(Left As Single, Top As Single, Width As Single, Height As Single, Optional Color As Variant, Optional FillColor As Variant)
    Me.Left = Left
    Me.Top = Top
    Me.Width = Width
    Me.Height = Height
    If Not IsMissing(Color) Then Me.Color = Color
    If Not IsMissing(FillColor) Then Me.FillColor = FillColor
End Sub

' draw this shape on a form, a picture box or the Printer object
Sub Draw(pic As Object)
    Dim aspect As Single, radius As Single
    Dim saveFillColor As Long, saveFillStyle As Long
    
    aspect = Height / Width
    radius = IIf(Width > Height, Width / 2, Height / 2)
    If FillColor >= 0 Then
        saveFillColor = pic.FillColor
        saveFillStyle = pic.FillStyle
        pic.FillColor = FillColor
        pic.FillStyle = vbSolid
        pic.Circle (Left + Width / 2, Top + Height / 2), radius, Color, , , aspect
        pic.FillColor = saveFillColor
        pic.FillStyle = saveFillStyle
    Else
        pic.Circle (Left + Width / 2, Top + Height / 2), radius, Color, , , aspect
    End If
End Sub

' move this object

Sub Move(stepX As Single, stepY As Single)
    Left = Left + stepX
    Top = Top + stepY
End Sub

' enlarge or shrink this object on its center

Sub Zoom(ZoomFactor As Single)
    Left = Left + Width * (1 - ZoomFactor) / 2
    Top = Top + Height * (1 - ZoomFactor) / 2
    Width = Width * ZoomFactor
    Height = Height * ZoomFactor
End Sub

