Attribute VB_Name = "Module1"
Option Explicit

Sub CopySubTree(SourceTV As TreeView, sourceND As Node, DestTV As TreeView, destND As Node)
    ' recursive routine that copies or moves all children of a node to another node
    Dim i As Long, so As Node, de As Node
    
    If sourceND.Children = 0 Then Exit Sub
    
    Set so = sourceND.Child
    For i = 1 To sourceND.Children
        ' add a node in the dest TreeView
        Set de = DestTV.Nodes.Add(destND, tvwChild, , so.Text, so.Image, so.SelectedImage)
        de.ExpandedImage = so.ExpandedImage
        
        ' now add all the children of this node, in a recursive manner
        CopySubTree SourceTV, so, DestTV, de
        
        ' get a reference to the next sibling
        Set so = so.Next
    Next
    
End Sub

Sub DeleteSubTree(TV As TreeView, Node As Node)
    ' recursively delete a subtree of nodes
    Dim i As Long, nd As Node, nd2 As Node
    
    ' if the node has one or more children, delete them first
    Set nd = Node.Child
    For i = 1 To Node.Children
        ' get a reference to the next node, before we delete this one
        Set nd2 = nd.Next
        DeleteSubTree TV, nd
        Set nd = nd2
    Next
    ' then delete this node
    TV.Nodes.Remove Node.Index
        
End Sub

