Attribute VB_Name = "Collections"
'---------------------------------------------------------
' PROGRAMMING VB6 ROUTINE LIBRARY - (C) Francesco Balena
'
' A collection of routines about Collections
'---------------------------------------------------------

Option Explicit

' returns True if an item in a collection actually exists

Function ItemExists(col As Collection, Key As String) As Boolean
    Dim dummy As Variant
    On Error Resume Next
    dummy = col.Item(Key)
    ItemExists = (Err = 0)
End Function

' remove all items in a collection

Sub RemoveAllItems(col As Collection)
    Do While col.count
        col.Remove 1
    Loop
End Sub

' replace an item in a collection
' INDEX can be either a numeric or a string value

Sub ReplaceItem(col As Collection, index As Variant, newValue As Variant)
    ' first, remove that item (exits with error if it doesn't exist)
    col.Remove index
    ' then, add it again
    If VarType(index) = vbString Then
        ' add a new item with the same string key
        col.Add newValue, index
    Else
        ' add a new item in the same position (without any key)
        col.Add newValue, , index
    End If
End Sub


