Attribute VB_Name = "DateTime"
'---------------------------------------------------------
' PROGRAMMING VB6 ROUTINE LIBRARY - (C) Francesco Balena
'
' A collection of date & time routines
'---------------------------------------------------------

Option Explicit

' wait for the current timer tick to elapse

Function NextTimerTick() As Single
    Dim t As Single
    t = Timer
    Do: Loop While t = Timer
    NextTimerTick = Timer
End Function

' insert a pause of a given duration (rounded to nearest integer)

Sub Pause(seconds As Integer)
    Const SECS_INDAY = 24! * 60 * 60    ' seconds per day
    Dim start As Single
    start = Timer
    Do: Loop Until (Timer + SECS_INDAY - start) Mod SECS_INDAY >= seconds
End Sub

' returns True if an year is a leap year

Function IsLeapYear(year As Integer) As Boolean
    ' does February 29 coincides with March 1 ?
    IsLeapYear = DateSerial(year, 2, 29) <> DateSerial(year, 3, 1)
End Function


