Attribute VB_Name = "KeyboardAPI"
Option Explicit

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function GetKeyboardState Lib "user32" (pbKeyState As Byte) As Long
Private Declare Function SetKeyboardState Lib "user32" (lppbKeyState As Byte) As Long

' Return True if the Ctrl key is pressed.

Function CtrlKey() As Boolean
    CtrlKey = (GetAsyncKeyState(vbKeyControl) And &H8000)
End Function

' Return True if the Shift key is pressed.

Function ShiftKey() As Boolean
    ShiftKey = (GetAsyncKeyState(vbKeyShift) And &H8000)
End Function

' Return True if the Alt key is pressed.

Function AltKey() As Boolean
    AltKey = (GetAsyncKeyState(vbKeyMenu) And &H8000)
End Function

' Return True if a given key is pressed.

Function KeysPressed(ByVal KeyCode1 As KeyCodeConstants, Optional ByVal KeyCode2 As KeyCodeConstants, Optional ByVal KeyCode3 As KeyCodeConstants) As Boolean
    If GetAsyncKeyState(KeyCode1) >= 0 Then Exit Function
    If KeyCode2 = 0 Then KeysPressed = True: Exit Function
    If GetAsyncKeyState(KeyCode2) >= 0 Then Exit Function
    If KeyCode3 = 0 Then KeysPressed = True: Exit Function
    If GetAsyncKeyState(KeyCode3) >= 0 Then Exit Function
    KeysPressed = True
End Function

' Read the state of CapsLock.
 
Function GetCapsLock() As Boolean
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetCapsLock = (keystat(vbKeyCapital) And 1)
End Function

' Modify the state of CapsLock.

Sub SetCapsLock(ByVal newValue As Boolean)
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyCapital) = (keystat(vbKeyCapital) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' Read the state of ScrollLock.
 
Function GetScrollLock() As Boolean
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetScrollLock = (keystat(vbKeyScrollLock) And 1)
End Function

' Modify the state of ScrollLock.

Sub SetScrollLock(ByVal newValue As Boolean)
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyScrollLock) = (keystat(vbKeyScrollLock) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' Read the state of NumLock.
 
Function GetNumLock() As Boolean
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetNumLock = (keystat(vbKeyNumlock) And 1)
End Function

' Modify the state of NumLock.

Sub SetNumLock(ByVal newValue As Boolean)
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyNumlock) = (keystat(vbKeyNumlock) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' Read the state of Insert Key.
 
Function GetInsertKey() As Boolean
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetInsertKey = (keystat(vbKeyInsert) And 1)
End Function

' Modify the state of Insert key.

Sub SetInsertKey(ByVal newValue As Boolean)
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyInsert) = (keystat(vbKeyInsert) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub


