VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Keyboard"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Keyboard routines"
'---------------------------------------------------------
' $CLSDESCR Keyboard routines
'---------------------------------------------------------
Option Explicit

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function GetKeyboardState Lib "user32" (pbKeyState As Byte) As Long
Private Declare Function SetKeyboardState Lib "user32" (lppbKeyState As Byte) As Long

' $DESCR Return True if the Ctrl key is pressed.

Function CtrlKey() As Boolean
Attribute CtrlKey.VB_Description = "Return True if the Ctrl key is pressed."
    CtrlKey = (GetAsyncKeyState(vbKeyControl) And &H8000)
End Function

' $DESCR Return True if the Shift key is pressed.

Function ShiftKey() As Boolean
Attribute ShiftKey.VB_Description = "Return True if the Shift key is pressed."
    ShiftKey = (GetAsyncKeyState(vbKeyShift) And &H8000)
End Function

' $DESCR Return True if the Alt key is pressed.

Function AltKey() As Boolean
Attribute AltKey.VB_Description = "Return True if the Alt key is pressed."
    AltKey = (GetAsyncKeyState(vbKeyMenu) And &H8000)
End Function

' $DESCR Return True if a given key is pressed.

Function KeysPressed(ByVal KeyCode1 As KeyCodeConstants, Optional ByVal KeyCode2 As KeyCodeConstants, Optional ByVal KeyCode3 As KeyCodeConstants) As Boolean
Attribute KeysPressed.VB_Description = "Return True if a given key is pressed."
    If GetAsyncKeyState(KeyCode1) >= 0 Then Exit Function
    If KeyCode2 = 0 Then KeysPressed = True: Exit Function
    If GetAsyncKeyState(KeyCode2) >= 0 Then Exit Function
    If KeyCode3 = 0 Then KeysPressed = True: Exit Function
    If GetAsyncKeyState(KeyCode3) >= 0 Then Exit Function
    KeysPressed = True
End Function

' $DESCR Read the state of CapsLock.
 
Function GetCapsLock() As Boolean
Attribute GetCapsLock.VB_Description = "Read the state of CapsLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetCapsLock = (keystat(vbKeyCapital) And 1)
End Function

' $DESCR Modify the state of CapsLock.

Sub SetCapsLock(ByVal newValue As Boolean)
Attribute SetCapsLock.VB_Description = "Modify the state of CapsLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyCapital) = (keystat(vbKeyCapital) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' $DESCR Read the state of ScrollLock.
 
Function GetScrollLock() As Boolean
Attribute GetScrollLock.VB_Description = "Read the state of ScrollLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetScrollLock = (keystat(vbKeyScrollLock) And 1)
End Function

' $DESCR Modify the state of ScrollLock.

Sub SetScrollLock(ByVal newValue As Boolean)
Attribute SetScrollLock.VB_Description = "Modify the state of ScrollLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyScrollLock) = (keystat(vbKeyScrollLock) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' $DESCR Read the state of NumLock.
 
Function GetNumLock() As Boolean
Attribute GetNumLock.VB_Description = "Read the state of NumLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetNumLock = (keystat(vbKeyNumlock) And 1)
End Function

' $DESCR Modify the state of NumLock.

Sub SetNumLock(ByVal newValue As Boolean)
Attribute SetNumLock.VB_Description = "Modify the state of NumLock."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyNumlock) = (keystat(vbKeyNumlock) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

' $DESCR Read the state of Insert Key.
 
Function GetInsertKey() As Boolean
Attribute GetInsertKey.VB_Description = "Read the state of Insert Key."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' for toggle keys, bit 0 reflects the current state
    GetInsertKey = (keystat(vbKeyInsert) And 1)
End Function

' $DESCR Modify the state of Insert key.

Sub SetInsertKey(ByVal newValue As Boolean)
Attribute SetInsertKey.VB_Description = "Modify the state of Insert key."
    ' get current state of all 256 virtual keys
    Dim keystat(0 To 255) As Byte
    GetKeyboardState keystat(0)
    ' modify bit 0 of the relevant item, and store back
    keystat(vbKeyInsert) = (keystat(vbKeyInsert) And &HFE) Or (newValue And 1)
    SetKeyboardState keystat(0)
End Sub

