VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ListViewAPI"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Routines for ListView controls"
'---------------------------------------------------------
' $CLSDESCR Routines for ListView controls
'---------------------------------------------------------
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageByVal Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, dest As Any, ByVal numBytes As Long)
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Const LVM_FIRST = &H1000
Attribute LVM_FIRST.VB_VarDescription = "Return the number of items that can fit vertically when in List or Report mode (only fully visible items are counted)."
Const LVM_GETCOUNTPERPAGE = (LVM_FIRST + 40)
Attribute LVM_GETCOUNTPERPAGE.VB_VarDescription = "Return the number of items that can fit vertically when in List or Report mode (only fully visible items are counted)."
Const LVM_SCROLL = (LVM_FIRST + 20)
Attribute LVM_SCROLL.VB_VarDescription = "Return the number of items that can fit vertically when in List or Report mode (only fully visible items are counted)."

' $DESCR Return the number of items that can fit vertically
' $DESCR when in List or Report mode (only fully visible items are counted)

Function LWVisibleLines(lvw As Object) As Long
Attribute LWVisibleLines.VB_Description = "Return the number of items that can fit vertically when in List or Report mode (only fully visible items are counted)."
    LWVisibleLines = SendMessageByVal(lvw.hWnd, LVM_GETCOUNTPERPAGE, 0, 0)
End Function

' $DESCR Scroll the contents horizontally and vertically.
' $DESCR If the ListView control is in List mode, DX is the number of
' $DESCR columns to scroll. If it is in Report mode, DY is rounded to the
' $DESCR nearest number of pixels that represent a whole line.

Function LWScroll(lvw As Object, ByVal dx As Long, ByVal dy As Long)
Attribute LWScroll.VB_Description = "Scroll the contents horizontally and vertically. If the ListView control is in List mode, DX is the number of columns to scroll. If it is in Report mode, DY is rounded to the nearest number of pixels that represent a whole line."
    SendMessageByVal lvw.hWnd, LVM_SCROLL, dx, dy
End Function

