Attribute VB_Name = "System"
'---------------------------------------------------------
' PROGRAMMING VB6 ROUTINE LIBRARY - (C) Francesco Balena
'
' A collection of Windows system routines
'---------------------------------------------------------

Option Explicit

' API declares (used by the WaitForProcess routine)
Private Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwAccess As _
    Long, ByVal fInherit As Integer, ByVal hObject As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

' wait for a number of milliseconds and return the running status of a
' process - if argument is omitted, wait until the process terminates

Function WaitForProcess(taskId As Long, Optional msecs As Long = -1) _
    As Boolean
        Dim procHandle As Long
        ' get the process handle
        procHandle = OpenProcess(&H100000, True, taskId)
        ' check for its signaled status, return to caller
        WaitForProcess = WaitForSingleObject(procHandle, msecs) <> -1
        ' close the handle
        CloseHandle procHandle
End Function




