Attribute VB_Name = "Trig"
'---------------------------------------------------------
' PROGRAMMING VB6 ROUTINE LIBRARY - (C) Francesco Balena
'
' A collection of trig routines
'---------------------------------------------------------

Option Explicit

' convert from degrees to radians

Function Radians(Degrees As Double) As Double
    Radians = Degrees / 57.29577951
End Function

' convert from radians to degrees

Function Degrees(Radians As Double) As Double
    Degrees = Radians * 57.29577951
End Function

' arc sine - error if NUMBER is outside the range [-1,1]

Function ASin(ByVal number As Double) As Double
    If Abs(number) <> 1 Then
        ASin = Atn(number / Sqr(1 - number * number))
    Else
        ASin = 1.5707963267949 * Sgn(number)
    End If
End Function

' arc cosine - error if NUMBER is outside the range [-1,1]

Function ACos(ByVal number As Double) As Double
    If Abs(number) <> 1 Then
        ACos = 1.5707963267949 - Atn(number / Sqr(1 - number * number))
    Else
        ACos = 3.14159265358979 * Sgn(number)
    End If
End Function

' arc tangent of Y/X
' returns values in all four quadrants

Function Atn2(x As Double, y As Double) As Double
    If x = 0 Then
        Atn2 = Sgn(y) * 1.5707963267949
    ElseIf x > 0 Then
        Atn2 = Atn(y / x)
    Else
        Atn2 = Atn(y / x) + 3.14159265358979 * (y < 0)
    End If
End Function

' convert from carthesian to polar coordinates
' Note: uses Atn2 routine

Sub XYToPolar(x As Double, y As Double, angle As Double, radius As Double)
    angle = Atn2(x, y)
    radius = Sqr(x * x + y * y)
End Sub

' convert from polar to carthesian coordinates

Sub PolarToXY(angle As Double, radius As Double, x As Double, y As Double)
    x = radius * Cos(angle)
    y = radius * Sin(angle)
End Sub



