VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FormSettings"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Routines for saving/restoring form settings."
'---------------------------------------------------------
' $CLSDESCR Routines for saving/restoring form settings.
'---------------------------------------------------------
Option Explicit

' $DESCR Save form settings

Function SaveFormSettings(ByVal AppName As String, frm As Object)
Attribute SaveFormSettings.VB_Description = "Save form settings."
    SaveSetting AppName, frm.name, "Left", frm.Left
    SaveSetting AppName, frm.name, "Top", frm.Top
    SaveSetting AppName, frm.name, "Width", frm.Width
    SaveSetting AppName, frm.name, "Height", frm.Height
    SaveSetting AppName, frm.name, "WindowState", frm.WindowState
End Function

' $DESCR Restore form settings.

Function LoadFormSettings(ByVal AppName As String, frm As Object)
Attribute LoadFormSettings.VB_Description = "Restore form settings."
    Dim currWindowState As Integer
    ' If the form is currently maximized or minimized, temporarily
    ' revert to normal state, otherwise the Move command fails.
    currWindowState = frm.WindowState
    If currWindowState <> 0 Then frm.WindowState = 0
    
    ' Use a Move method to avoid multiple Resize and Paint events.
    frm.Move GetSetting(AppName, frm.name, "Left", frm.Left), _
        GetSetting(AppName, frm.name, "Top", frm.Top), _
        GetSetting(AppName, frm.name, "Width", frm.Width), _
        GetSetting(AppName, frm.name, "Height", frm.Height)
    frm.WindowState = GetSetting(AppName, frm.name, "WindowState", currWindowState)
End Function

' $DESCR Delete form settings.

Sub DeleteFormSettings(ByVal AppName As String, frm As Object)
Attribute DeleteFormSettings.VB_Description = "Delete form settings."
    DeleteSetting AppName, frm.name
End Sub

