VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Window"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Routines for getting window information"
'---------------------------------------------------------
' $CLSDESCR Routines for getting window information
'---------------------------------------------------------

Option Explicit

Private Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumChildWindows Lib "user32" (ByVal hWndParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

' $DESCR Return an array of Long holding the handles of all the child windows
' $DESCR of a given window. If hWnd = 0 it returns all the top-level windows.

Function ChildWindows(ByVal hWnd As Long) As Long()
Attribute ChildWindows.VB_Description = "Return an array of Long holding the handles of all the child windows of a given window. If hWnd = 0 it returns all the top-level windows."
    windowsCount = 0
    If hWnd Then
        EnumChildWindows hWnd, AddressOf EnumWindows_CBK, 1
    Else
        EnumWindows AddressOf EnumWindows_CBK, 1
    End If
    ' Trim uninitialized elements and return to caller.
    ReDim Preserve windows(windowsCount) As Long
    ChildWindows = windows()
End Function

' $DESCR Return the caption/text of a window.

Function WindowText(ByVal hWnd As Long) As String
Attribute WindowText.VB_Description = "Return the caption/text of a window."
    Dim buffer As String * 256, length As Long
    length = GetWindowText(hWnd, buffer, Len(buffer))
    WindowText = Left$(buffer, length)
End Function

' $DESCR Return the classname of a window.

Function WindowClassName(ByVal hWnd As Long) As String
Attribute WindowClassName.VB_Description = "Return the classname of a window."
    Dim buffer As String * 256, length As Long
    length = GetClassName(hWnd, buffer, Len(buffer))
    WindowClassName = Left$(buffer, length)
End Function

' $DESCR Return the full description of a window (hwnd, classname, caption).

Function WindowDescription(ByVal hWnd As Long) As String
Attribute WindowDescription.VB_Description = "Return the full description of a window (hwnd, classname, caption)."
    Dim text As String
    text = WindowText(hWnd)
    
    WindowDescription = "[" & Right$("0000000" & Hex$(hWnd), 8) & "] " _
        & WindowClassName(hWnd)
    If Len(text) Then
        WindowDescription = WindowDescription & " - """ & text & """"
    End If
End Function

