VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QueryToTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Public Properties ------------------------

' True if Record numbers must be displayed.
Public ShowRecNumbers As Boolean

' Private members ---------------------------

Private Type FieldsUDT
    FldName As String
    Caption As String
    HAlign As String
    VAlign As String
    PrefixTag As String
    PostfixTag As String
End Type

' A reference to the ASP library'entry point.
Dim sc As ASPTypeLibrary.ScriptingContext

' The Recordset being opened
Dim rs As ADODB.Recordset

' Array information about the fields
Dim Fields() As FieldsUDT
' Number of Fields in Fields
Dim FieldCount As Integer

' This event fires when the component is instantiated
' from within the ASP page.
Sub OnStartPage(AspSC As ASPTypeLibrary.ScriptingContext)
    ' Save the reference for later.
    Set sc = AspSC
    ResetFields
End Sub

' Execute an SQL query.
Function Execute(conn As String, sql As String)
    ' Execute the query
    Set rs = New ADODB.Recordset
    rs.Open sql, conn, adOpenStatic, adLockReadOnly
End Function

' Reset field information.
Sub ResetFields()
    Dim Fields(0) As FieldsUDT
    FieldCount = 0
End Sub

' Add a field to the Layout.
Sub AddField(FldName As String, Optional Caption As String, Optional HAlign As String, Optional VAlign As String, Optional PrefixTag As String, Optional PostfixTag As String)
    ' Check values.
    If FldName = "" Then Err.Raise 5

    ' Add to the internal array.
    FieldCount = FieldCount + 1
    ReDim Preserve Fields(0 To FieldCount) As FieldsUDT
    With Fields(FieldCount)
        .FldName = FldName
        .Caption = Caption
        .HAlign = HAlign
        .VAlign = VAlign
        .PrefixTag = PrefixTag
        .PostfixTag = PostfixTag
        
        ' The default caption is the field's name.
        If .Caption = "" Then .Caption = FldName
        
        ' The default horizontal alignment is "left"
        Select Case LCase$(.HAlign)
            Case "left", "center", "right"
            Case Else
                .HAlign = "left"
        End Select
        .HAlign = " ALIGN=" & .HAlign
        
        ' The default vertucal alignment is "top"
        Select Case LCase$(.VAlign)
            Case "top", "middle", "bottom"
            Case Else
                .VAlign = "top"
        End Select
        .VAlign = " VALIGN=" & .VAlign

    End With
    
    
End Sub

' Initialize the Fields() array with suitable values.
Private Sub InitFields()
    Dim i As Integer, j As Integer
    Dim fld As ADODB.Field
    
    ResetFields
    For Each fld In rs.Fields
        AddField fld.Name
    Next
End Sub

' Generate the HTML text for the table.
Sub GenerateHTML()
    Dim i As Integer, recNum As Long
    Dim f As FieldsUDT
    
    ' Initialize Fields() if not done already
    If FieldCount = 0 Then InitFields
    
    ' Restart from the first record.
    rs.MoveFirst
    
    ' Output the table header and border.
    Send "<TABLE BORDER=1>"
    Send "  <THEAD>"
    Send "   <TR>"
    ' Insert a column for Record Number, if requested.
    If ShowRecNumbers Then
        Send "    <TH ALIGN=Center>Rec #</TH>"
    End If
    ' These are the fields' captions.
    For i = 1 To UBound(Fields)
        f = Fields(i)
        Send "    <TH" & f.HAlign & ">" & f.Caption & "</TH>"
    Next
    Send "   </TR>"
    Send "  </THEAD>"
    Send " <TBODY>"
    
    ' Output the body of the table.
    Do Until rs.EOF
        
        ' Add a new row of cells.
        Send "  <TR>"
        ' Add Record Number if requested
        recNum = recNum + 1
        If ShowRecNumbers Then
            Send "   <TD ALIGN=center>" & recNum & "</TD>"
        End If
        
        ' Send all the fields of the current record.
        For i = 1 To UBound(Fields)
            f = Fields(i)
            Send "   <TD" & f.HAlign & f.VAlign & ">" & f.PrefixTag & rs(f.FldName) & f.PostfixTag & "</TD>"
        Next
        Send "  </TR>"
        ' Advance to the next record.
        rs.MoveNext
    Loop
        
    ' Close the table.
    Send " </TBODY>"
    Send "</TABLE>"

End Sub

' Send a line of text to the output stream.
Sub Send(Text As String)
    sc.Response.Write Text
End Sub

