Attribute VB_Name = "TimerModule"
Option Explicit

Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, ByVal nIDEvent As Long) As Long

' This is the ID of the timer created.
Dim timerID As Long

Sub StartTimer(ByVal timeout As Long)
    ' Don't start the timer if it's already running.
    If timerID = 0 Then
        timerID = SetTimer(0, 0, timeout, AddressOf Timer_CBK)
    End If
End Sub

Sub StopTimer()
    ' Don't stop the timer if it isn't running.
    If timerID Then
        KillTimer 0, timerID
        timerID = 0
    End If
End Sub

Sub Timer_CBK(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal SysTime As Long)
    ' Just display the system time in a label control.
    Form1.lblTimer = SysTime
End Sub
