Attribute VB_Name = "ListViewAPI"
Option Explicit

'---------------------------------------------------
' Reusable routines for ListView controls
'---------------------------------------------------

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageByVal Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, dest As Any, ByVal numBytes As Long)
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


Const LVM_FIRST = &H1000
Const LVM_GETCOUNTPERPAGE = (LVM_FIRST + 40)
Const LVM_SCROLL = (LVM_FIRST + 20)

' Return the number of items that can fit vertically
' when in List or Report mode (only fully visible items are counted)

Function VisibleLines(lvw As ListView) As Long
    VisibleLines = SendMessageByVal(lvw.hwnd, LVM_GETCOUNTPERPAGE, 0, 0)
End Function

' Scroll the contents horizontally and vertically.
' If the ListView control is in List mode, DX is the number of
' columns to scroll. If it is in Report mode, DY is rounded to the
' nearest number of pixels that represent a whole line.

Function Scroll(lvw As ListView, ByVal dx As Long, ByVal dy As Long)
    SendMessageByVal lvw.hwnd, LVM_SCROLL, dx, dy
End Function

