Attribute VB_Name = "SubclassingAPI"
Option Explicit

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal ndx As Long, ByVal newValue As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' This is used with the SetWindowLong API function.
Const GWL_WNDPROC = -4

' Some message constants.
Const WM_MOVE = &H3
Const WM_SIZING = &H214
Const WM_ACTIVATEAPP = &H1C

' --------------------------------------------

Dim saveHWnd As Long        ' The handle of the subclassed window.
Dim oldProcAddr As Long     ' The address of the original window procedure

Sub StartSubclassing(ByVal hWnd As Long)
    saveHWnd = hWnd
    oldProcAddr = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WndProc)
End Sub

Sub StopSubclassing()
    SetWindowLong saveHWnd, GWL_WNDPROC, oldProcAddr
End Sub

Function WndProc(ByVal hWnd As Long, ByVal uMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
    ' Send the message to the original window procedure, and then
    ' return Windows the return value from the original procedure.
    WndProc = CallWindowProc(oldProcAddr, hWnd, uMsg, wParam, lParam)
    
    ' See if this is one of the messages we're waiting for.
    ' In this demo we simply show an informative message in the window.
    Select Case uMsg
        Case WM_MOVE
            NotifyMsg "Windows has moved"
        Case WM_SIZING
            NotifyMsg "Windows is being resized"
        Case WM_ACTIVATEAPP
            If wParam Then
                NotifyMsg "The application got the focus"
            Else
                NotifyMsg "The application lost the focus"
            End If
    End Select
End Function

' Notify the event to the window. In this demo we simply
' add an element in a ListBox control.

Sub NotifyMsg(text As String)
    Form1.lstMessages.AddItem text
    Form1.lstMessages.ListIndex = Form1.lstMessages.ListCount - 1
End Sub
