Attribute VB_Name = "RegistryFunctions"
Option Explicit

Function SaveFormSettings(ByVal AppName As String, frm As Form)
    SaveSetting AppName, frm.Name, "Left", frm.Left
    SaveSetting AppName, frm.Name, "Top", frm.Top
    SaveSetting AppName, frm.Name, "Width", frm.Width
    SaveSetting AppName, frm.Name, "Height", frm.Height
    SaveSetting AppName, frm.Name, "WindowState", frm.WindowState
End Function

Function LoadFormSettings(ByVal AppName As String, frm As Form)
    Dim currWindowState As Integer
    ' If the form is currently maximized or minimized, temporarily
    ' revert to normal state, otherwise the Move command fails.
    currWindowState = frm.WindowState
    If currWindowState <> 0 Then frm.WindowState = 0
    
    ' Use a Move method to avoid multiple Resize and Paint events.
    frm.Move GetSetting(AppName, frm.Name, "Left", frm.Left), _
        GetSetting(AppName, frm.Name, "Top", frm.Top), _
        GetSetting(AppName, frm.Name, "Width", frm.Width), _
        GetSetting(AppName, frm.Name, "Height", frm.Height)
    frm.WindowState = GetSetting(AppName, frm.Name, "WindowState", currWindowState)
End Function

' Delete form settings

Sub DeleteFormSettings(ByVal AppName As String, frm As Form)
    DeleteSetting AppName, frm.Name
End Sub
